Index: sansview/perspectives/fitting/basepage.py
===================================================================
--- sansview/perspectives/fitting/basepage.py	(revision cd57979a99cf1210a63de717ee06ad3cc70d504c)
+++ sansview/perspectives/fitting/basepage.py	(revision 52cac46f7ecfa0ccac0494eec0082af1984a15b0)
@@ -654,5 +654,83 @@
         self._copy_parameters_state(self.fixed_param, self.state.fixed_param)
     
-    
+
+    def save_current_state_fit(self):
+        """
+            Store current state
+        """
+        ## save model option
+        if self.model!= None:
+            self.disp_list= self.model.getDispParamList()
+            self.state.disp_list= copy.deepcopy(self.disp_list)
+            self.state.model = self.model.clone()
+            
+        self.state.enable2D = copy.deepcopy(self.enable2D)
+        self.state.values= copy.deepcopy(self.values)
+        self.state.weights = copy.deepcopy( self.weights)
+        ## save data    
+        self.state.data= copy.deepcopy(self.data)
+        try:
+            n = self.disp_box.GetCurrentSelection()
+            dispersity= self.disp_box.GetClientData(n)
+            name= dispersity.__name__
+            self.disp_name = name
+            if name == "GaussianDispersion" :
+               if hasattr(self,"cb1"):
+                   self.state.cb1= self.cb1.GetValue()
+        except:
+            pass
+        
+        if hasattr(self,"enable_disp"):
+            self.state.enable_disp= self.enable_disp.GetValue()
+            self.state.disable_disp = self.disable_disp.GetValue()
+            
+        self.state.smearer = copy.deepcopy(self.smearer)
+        if hasattr(self,"enable_smearer"):
+            self.state.enable_smearer = copy.deepcopy(self.enable_smearer.GetValue())
+            self.state.disable_smearer = copy.deepcopy(self.disable_smearer.GetValue())
+            
+        if hasattr(self,"disp_box"):
+            self.state.disp_box = self.disp_box.GetCurrentSelection()
+
+            if len(self.disp_cb_dict)>0:
+                for k , v in self.disp_cb_dict.iteritems():
+         
+                    if v ==None :
+                        self.state.disp_cb_dict[k]= v
+                    else:
+                        try:
+                            self.state.disp_cb_dict[k]=v.GetValue()
+                        except:
+                            self.state.disp_cb_dict[k]= None
+           
+            if len(self._disp_obj_dict)>0:
+                for k , v in self._disp_obj_dict.iteritems():
+      
+                    self.state._disp_obj_dict[k]= v
+                        
+            
+            self.state.values = copy.deepcopy(self.values)
+            self.state.weights = copy.deepcopy(self.weights)
+        ## save plotting range
+        self._save_plotting_range()
+        
+        #self.state.orientation_params =[]
+        #self.state.orientation_params_disp =[]
+        #self.state.parameters =[]
+        #self.state.fittable_param =[]
+        #self.state.fixed_param =[]
+
+        
+        ## save checkbutton state and txtcrtl values
+        self._copy_parameters_state(self.orientation_params,
+                                     self.state.orientation_params)
+        self._copy_parameters_state(self.orientation_params_disp,
+                                     self.state.orientation_params_disp)
+        
+        self._copy_parameters_state(self.parameters, self.state.parameters)
+        self._copy_parameters_state(self.fittable_param, self.state.fittable_param)
+        self._copy_parameters_state(self.fixed_param, self.state.fixed_param)
+    
+               
     def reset_page_helper(self, state):
         """
Index: sansview/perspectives/fitting/fitpage.py
===================================================================
--- sansview/perspectives/fitting/fitpage.py	(revision 4043c9668261a89f2104588d283f6f2ac3ac55ff)
+++ sansview/perspectives/fitting/fitpage.py	(revision 52cac46f7ecfa0ccac0494eec0082af1984a15b0)
@@ -1080,13 +1080,14 @@
                     item[0].SetValue(False)
                 self.param_toFit=[]
-        self._copy_parameters_state(self.orientation_params,
-                                     self.state.orientation_params)
-        self._copy_parameters_state(self.orientation_params_disp,
-                                     self.state.orientation_params_disp)
-        self._copy_parameters_state(self.parameters, self.state.parameters)
-        self._copy_parameters_state(self.fittable_param, self.state.fittable_param)
-        self._copy_parameters_state(self.fixed_param, self.state.fixed_param)
+                
+        #self._copy_parameters_state(self.orientation_params,
+        #                             self.state.orientation_params)
+        #self._copy_parameters_state(self.orientation_params_disp,
+        #                            self.state.orientation_params_disp)
+        #self._copy_parameters_state(self.parameters, self.state.parameters)
+        #self._copy_parameters_state(self.fittable_param, self.state.fittable_param)
+        #self._copy_parameters_state(self.fixed_param, self.state.fixed_param)
            
-        self.save_current_state()  
+        self.save_current_state_fit()  
         if event !=None:
             #self._undo.Enable(True)
@@ -1127,14 +1128,14 @@
             self.cb1.SetValue(False)
         ## save current state of the page
-        self.state.cb1 = self.cb1.GetValue()
-        self._copy_parameters_state(self.orientation_params,
-                                     self.state.orientation_params)
-        self._copy_parameters_state(self.orientation_params_disp,
-                                     self.state.orientation_params_disp)
-        self._copy_parameters_state(self.parameters, self.state.parameters)
-        self._copy_parameters_state(self.fittable_param, self.state.fittable_param)
-        self._copy_parameters_state(self.fixed_param, self.state.fixed_param)
-        
-        self.save_current_state()
+        #self.state.cb1 = self.cb1.GetValue()
+        #self._copy_parameters_state(self.orientation_params,
+        #                             self.state.orientation_params)
+        #self._copy_parameters_state(self.orientation_params_disp,
+        #                             self.state.orientation_params_disp)
+        #self._copy_parameters_state(self.parameters, self.state.parameters)
+        #self._copy_parameters_state(self.fittable_param, self.state.fittable_param)
+        #self._copy_parameters_state(self.fixed_param, self.state.fixed_param)
+        
+        self.save_current_state_fit()
         if event !=None:
             #self._undo.Enable(True)
@@ -1427,13 +1428,13 @@
             else:
                 self.text2_4.Hide()
-                
-        self._copy_parameters_state(self.orientation_params,
-                                     self.state.orientation_params)
-        self._copy_parameters_state(self.orientation_params_disp,
-                                     self.state.orientation_params_disp)
-        self._copy_parameters_state(self.parameters, self.state.parameters)
-        self._copy_parameters_state(self.fittable_param, self.state.fittable_param)
-        self._copy_parameters_state(self.fixed_param, self.state.fixed_param)
-        
+        #self.state.cb1 = self.cb1.GetValue()        
+        #self._copy_parameters_state(self.orientation_params,
+        #                             self.state.orientation_params)
+        #self._copy_parameters_state(self.orientation_params_disp,
+        #                             self.state.orientation_params_disp)
+        #self._copy_parameters_state(self.parameters, self.state.parameters)
+        #self._copy_parameters_state(self.fittable_param, self.state.fittable_param)
+        #self._copy_parameters_state(self.fixed_param, self.state.fixed_param)
+        self.save_current_state_fit()
         boxsizer1.Add(sizer)
         self.sizer3.Add(boxsizer1,0, wx.EXPAND | wx.ALL, 10)
@@ -1442,5 +1443,6 @@
         self.Refresh()
         self.SetScrollbars(20,20,25,65)
-       
+
+
         
 class HelpWindow(wx.Frame):
